<?php
/**
 * @project Astra.CMS
 * @link http://a-cms.ru/
 * @copyright 2010 "Астра Вебтехнологии"
 * @author Vitaly Hohlov <vitaly.hohlov@gmail.com>
 * @package Plugins
 */
/**************************************************************************/

class Groups_Request extends A_Request
{
  function Action($action)
  {
    switch($action)
    { case "getaddgroupform": $this->getAddGroupForm(); break;
	  case "geteditgroupform": $this->getEditGroupForm(); break;
    }
  }

  function getAddGroupForm()
  {
    $form = new A_Form("plugin_groups_add.tpl");
	$nologin=A::$DB->existsRow("SELECT id FROM ".STRUCTURE." WHERE idsec=0");
	$form->data['authsections']=!$nologin?array(0=>"Без авторизации"):array();

	A::$DB->query("SELECT id,caption FROM ".DOMAIN."_sections WHERE module='users' ORDER BY sort");
	while($row=A::$DB->fetchRow())
	$form->data['authsections'][$row['id']]=$row['caption'];
	A::$DB->free();

	$form->data['idsec']=key($form->data['authsections']);

	$form->data['sections']=array();
	A::$DB->query("SELECT * FROM ".DOMAIN."_sections ORDER BY sort");
	while($row=A::$DB->fetchRow())
	{ $row['access']=array();
	  $row['access'][]=array('name'=>'read','caption'=>"Чтение",'auth'=>false);
	  if(function_exists($row['module']."_SpecialSectionAccess"))
	  { $section=getDomain(STRUCTURE)."_".$row['lang']."_".$row['name'];
	    call_user_func($row['module']."_SpecialSectionAccess",&$row['access'],$section);
	  }
	  elseif(function_exists($row['module']."_Access"))
	  call_user_func($row['module']."_Access",&$row['access']);
	  $form->data['sections'][]=$row;
	}
	A::$DB->free();

	if(count($form->data['authsections'])>0)
	$this->RESULT['html'] = $form->getContent();
	else
	$this->RESULT['html'] = AddLabel("Не найдены разделы пользователей.");
  }

  function getEditGroupForm()
  {
    $form = new A_Form("plugin_groups_edit.tpl");
	$form->data=A::$DB->getRowById($_POST['id'],STRUCTURE);
	$nologin=A::$DB->existsRow("SELECT id FROM ".STRUCTURE." WHERE idsec=0 AND id<>".$_POST['id']);
	$form->data['authsections']=!$nologin?array(0=>"Без авторизации"):array();

	A::$DB->query("SELECT id,caption FROM ".DOMAIN."_sections WHERE module='users' ORDER BY sort");
	while($row=A::$DB->fetchRow())
	$form->data['authsections'][$row['id']]=$row['caption'];
	A::$DB->free();

	$access=!empty($form->data['access'])?unserialize($form->data['access']):array();

	$form->data['sections']=array();
	A::$DB->query("SELECT * FROM ".DOMAIN."_sections ORDER BY sort");
	while($row=A::$DB->fetchRow())
	{ $row['access']=array();
	  $row['access'][]=array('name'=>'read','caption'=>"Чтение",'auth'=>false);
	  if(function_exists($row['module']."_SpecialSectionAccess"))
	  { $section=getDomain(STRUCTURE)."_".$row['lang']."_".$row['name'];
	    call_user_func($row['module']."_SpecialSectionAccess",&$row['access'],$section);
	  }
	  elseif(function_exists($row['module']."_Access"))
	  call_user_func($row['module']."_Access",&$row['access']);
	  foreach($row['access'] as $i=>$a)
	  $row['access'][$i]['checked']=isset($access[$row['id']]) && in_array($a['name'],$access[$row['id']]);
	  $form->data['sections'][]=$row;
	}
	A::$DB->free();

	if(count($form->data['authsections'])>0)
	$this->RESULT['html'] = $form->getContent();
	else
	$this->RESULT['html'] = AddLabel("Не найдены разделы пользователей.");
  }
}

A::$REQUEST = new Groups_Request;